package com.gic.haoban.app.daily.mobile.web.controller;

import com.gic.haoban.app.daily.mobile.web.errCode.HaoBanErrCode;
import com.gic.haoban.common.utils.HaobanResponse;

import java.util.ArrayList;
import java.util.List;

/**
 * Created 2018/7/18.
 * @author hua
 */

public class WebBaseController{

    protected final String defaultReturn = "json";


    public HaobanResponse resultResponse(HaoBanErrCode errCode,Object data,String detailError){
        HaobanResponse response = new HaobanResponse();
        response.setMessage( errCode.getMsg() );
        response.setErrorCode( errCode.getCode() );
        response.setResult( data );
        response.setDetailError( detailError );
        return response;
    }

    public HaobanResponse resultResponse(HaoBanErrCode errCode,List<?> data){
        if( data == null ){
            data = new ArrayList<>();
        }
        return resultResponse( errCode,data,null );
    }

    public HaobanResponse resultResponse(HaoBanErrCode errCode,Object data){
        return resultResponse( errCode,data,"" );
    }

    public HaobanResponse resultResponse(HaoBanErrCode errCode){
        return resultResponse( errCode,null,"" );
    }

    /**
     * 缺少必要参数
     * @return
     */
    protected HaobanResponse missArgument(){
        return resultResponse( HaoBanErrCode.ERR_2,null,"" );
    }

    protected HaobanResponse success(){
        return resultResponse( HaoBanErrCode.ERR_1,null,"" );
    }

    protected HaobanResponse success(Object data){
        return resultResponse( HaoBanErrCode.ERR_1,data,"" );
    }
}
