package com.gic.haoban.app.daily.mobile.web.exception;

import com.gic.haoban.app.daily.mobile.web.controller.WebBaseController;
import com.gic.haoban.app.daily.mobile.web.errCode.HaoBanErrCode;
import com.gic.haoban.base.api.common.ShowFrontMessageException;
import com.gic.haoban.common.utils.HaobanResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;

/**
 * Created 2018/7/24.
 *
 * @author hua
 */
@ControllerAdvice
public class GlobalExceptionHandler extends WebBaseController{
    private static Logger logger = LoggerFactory.getLogger(GlobalExceptionHandler.class);

    @ResponseBody
    @ExceptionHandler(Exception.class)
    public HaobanResponse ControllerException(HttpServletResponse response, Exception ex) {
        logger.error("err");
        ex.printStackTrace();
        StringBuilder sb = new StringBuilder();
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        try (PrintWriter printWriter = new PrintWriter(baos)) {
            ex.printStackTrace(printWriter);
        }
        try {
            sb.append(baos.toString());
        } catch (Exception ignored) {
        }
        if (sb.length() == 0) {
            sb.append(ex.getMessage());
        }

        // 输出详细错误信息，便于调试
        return resultResponse(HaoBanErrCode.ERR_3, null, sb.toString());
    }

    @ResponseBody
    @ExceptionHandler(ShowFrontMessageException.class)
    public HaobanResponse ControllerException(HttpServletResponse response, ShowFrontMessageException ex) {
        HaobanResponse res = new HaobanResponse();
        res.setErrorCode(HaoBanErrCode.ERR_0.getCode());
        res.setMessage(ex.getMessage());
        return res;
    }


}
