package com.gic.haoban.app.daily.mobile.web.interceptor;

import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;

/**
 * Created 2018/7/20.
 * @author hua
 */
public class WebInterceptor extends HandlerInterceptorAdapter{

    private static Logger logger = LoggerFactory.getLogger( WebInterceptor.class );


    @Override
    public boolean preHandle(HttpServletRequest httpServletRequest,HttpServletResponse httpServletResponse,Object o) throws Exception{
        String requestURI = httpServletRequest.getRequestURI();
        logger.info( "post-url:{}",requestURI );
        Map<String, String[]> parameterMap = httpServletRequest.getParameterMap();
        logger.info( "post-params:{}",JSONObject.toJSONString( parameterMap ) );
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest httpServletRequest,HttpServletResponse httpServletResponse,Object o,ModelAndView modelAndView) throws Exception{
        logger.info( "end" );
    }

    @Override
    public void afterCompletion(HttpServletRequest httpServletRequest,HttpServletResponse httpServletResponse,Object o,Exception e) throws Exception{
        logger.info( "end" );
    }
}
