package com.gic.haoban.app.daily.web.utils;

import com.gic.haoban.app.daily.web.errcode.HaoBanErrCode;
import com.gic.haoban.common.utils.HaobanResponse;

/**
 * @author 蘑小菇
 * @Description:
 * @date 2019/3/4 16:45
 */
public class ResultBuilder {


    public static HaobanResponse build(HaoBanErrCode errCode,Object data,String detailError) {
        HaobanResponse response = new HaobanResponse();
        response.setMessage(errCode.getMsg());
        response.setErrorCode(errCode.getCode());
        response.setResult(data);
        response.setDetailError(detailError);
        return response;
    }



    /**
     * 返回成功的结果
     * @param data
     * @return
     */
    public static HaobanResponse success(Object data) {
        return build(HaoBanErrCode.ERR_1, data, "");
    }

    public static HaobanResponse successMsg(String msg) {
        HaobanResponse response = new HaobanResponse();
        response.setMessage(msg);
        response.setErrorCode(HaoBanErrCode.ERR_1.getCode());
        response.setResult(null);
        response.setDetailError("");
        return response;
    }

    public static HaobanResponse fail(HaoBanErrCode errCode, String detailError) {
        return build(errCode, null, detailError);
    }

    public static HaobanResponse fail(String detailError) {
        return build(HaoBanErrCode.ERR_0, null, detailError);
    }

    public static HaobanResponse fail(HaoBanErrCode errCode) {
        return build(errCode, null, null);
    }

}
